; dotted tail notation
; Build a list of the numbers in y with the same even/odd parity as x.
; x - an even or odd number
; y - all the remaining arguments stored as a list.
; return a list with x followed by all the numbers of the same parity

(define (same-parity x . y)
  (define (iter shrink)
    (cond 
      ((null? shrink) '())
      ((or (and (odd? x) (odd? (car shrink)))
           (and (even? x) (even? (car shrink))))
       (cons (car shrink) (iter (cdr shrink))))
      (else 
       (iter (cdr shrink)))))
  (cons x (iter y)))

(same-parity 1 2 3 4 5 6 7)
(same-parity 2 3 4 5 6 7)
 